!
subroutine DE30(DS2, A, B, N, Y, DY)
!Declarations
interface
  subroutine DS2(X, Y, DY, DDY)
  real, intent(in):: X, Y(:), DY(:)
  real:: DDY(:)
  end subroutine DS2
end interface
real, intent(in):: A, B
integer, intent(in):: N
real, intent(inout):: Y(:), DY(:)
real, allocatable:: C1(:), C2(:), K1(:), K2(:), K3(:), K4(:)
real:: X, H, Hd2, Hd6
integer:: i, k, M
!begin
  if (A==B) return
  H=(B-A)/float(N)
  Hd2=0.5*H; Hd6=H/6.0
  M=size(Y)
  allocate (C1(M), C2(M), K1(M), K2(M), K3(M), K4(M))
  do k=0, N-1
    X=A+H*float(k)
    call DS2(X, Y, DY, K1)
    do i=1, M
      K1(i)=H*K1(i)
      C1(i)=Y(i)+Hd2*DY(i)
      C2(i)=DY(i)+0.5*K1(i)
    end do
    call DS2(X+Hd2, C1, C2, K2)
    do i=1, M
      K2(i)=H*K2(i)
      C1(i)=Y(i)+Hd2*C2(i)
      C2(i)=DY(i)+0.5*K2(i)
    end do
    call DS2(X+Hd2, C1, C2, K3)
    do i=1, M
      K3(i)=H*K3(i)
      C1(i)=Y(i)+H*C2(i)
      C2(i)=DY(i)+K3(i)
    end do
    call DS2(X+H, C1, C2, K4)
    do i=1, M
      K4(i)=H*K4(i)
      Y(i)=Y(i)+H*DY(i)+Hd6*(K1(i)+K2(i)+K3(i))
      DY(i)=DY(i)+(K1(i)+2.0*K2(i)+2.0*K3(i)+K4(i))/6.0
    end do
  end do
  deallocate (C1, C2, K1, K2, K3, K4)
  return
end subroutine DE30
